<xsl:stylesheet version="2.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:template match="addrLine2">

    <xsl:variable name="elValue" select="."/>

    <xsl:analyze-string select="$elValue"
                        regex="\s*(.*)\s*,\s*([A-Z]{{2}})\s+(\d{{5}}(\-\d{{4}})?)\s*">

      <xsl:matching-substring>
        <city><xsl:value-of select="regex-group(1)"/></city>
        <state><xsl:value-of select="regex-group(2)"/></state>
        <zip><xsl:value-of select="regex-group(3)"/></zip>
      </xsl:matching-substring>

      <xsl:non-matching-substring>
        <addrLine2>
          <xsl:value-of select="$elValue"/>
        </addrLine2>
      </xsl:non-matching-substring>

    </xsl:analyze-string>

  </xsl:template>

  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>